#ifndef _DXMACRO_H_
#define _DXMACRO_H_

#define SAFE_DELETE(p)       { if(p) { delete (p);     (p)=NULL; } }
#define SAFE_DELETE_ARRAY(p) { if(p) { delete[] (p);   (p)=NULL; } }
#define SAFE_RELEASE(p)      { if(p) { (p)->Release(); (p)=NULL; } }

inline DWORD F2DW( FLOAT f ) { return *((DWORD*)&f); }

// eNX`쐬
inline HRESULT CreateTexture( LPDIRECT3DDEVICE9 pd3dDevice, TCHAR* strTexture,
							LPDIRECT3DTEXTURE9* ppTexture, D3DFORMAT d3dFormat )
{
	return D3DXCreateTextureFromFileEx( pd3dDevice, strTexture, 
				D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0, d3dFormat, 
				D3DPOOL_MANAGED, D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 
				D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 0, NULL, NULL, ppTexture );
}

#endif