// ECTt@C\
// ĎOp`|Sɕϊς݂ECTt@C͓ǂݍ݂
#ifndef _FILE_ECT_H_
#define _FILE_ECT_H_

#include "macro.h"
#include "fvf.h"

#define A_MAX	256 	// AjZbgő吔
#define M_MAX	256 	// [Vő吔
#define P_MAX	256 	// p[c+jbgő吔
#define LEN_MAX 64		// Aj̍ő啶

enum ALPHA_FLAG // At@ ufBO tO
{
	ALPHA_NONE, // Ȃ
	ALPHA_HALF, // 
	ALPHA_ADD	// Z
};

enum MODEL_FLAG // f tO
{
	MODEL_BINARY		=  1,	// oCi`
	MODEL_SKIN			=  2,	// XL
	MODEL_TRANSLATION	=  4,	// sړ
	MODEL_SCALE 		=  8,	// gk
	MODEL_ANIMATION 	= 16,	// Ajݒ肠
	MODEL_3VERTEX		= 32,	// 3_|Ŝ
	MODEL_ALPHA 		= 64,	// }eA
	MODEL_TEXTURE_ALL	= 128	// eNX`}bv̍őlAp[cł͂ȂAfS
};

typedef struct{
	LPDIRECT3DTEXTURE9	pTex;	// eNX` IuWFNg
}TEXTURE,*LPTEXTURE;

typedef struct{
	DWORD		flag_model; // f tOiMODEL_FLAG ̑gݍ킹j
	LPD3DXMESH	pMesh;		// bV
	int 		parts_ct;	// p[c
	int 		mt_ct;		// [V
	int 		unit_ct;	// jbg
	int 		anim_ct;	// Aj
	LPTEXTURE	pTexture;	// eNX`
	int			texture_ct; // eNX`
	D3DXVECTOR3 t_center;	// fS_
	D3DXVECTOR3 t_bbox_min; // oEfBO{bNX̍W
	D3DXVECTOR3 t_bbox_max; // oEfBO{bNX̉EW
}MODEL,*LPMODEL;

typedef struct{
	DWORD			flag_alpha; 	// At@ufBOtOiALPHA_FLAG ̓ǂꂩ1j
	int 			flag_wrap;		// eNX` bsO tOi0,1:Ȃ 2:j
	int 			vtx_ct; 		// _
	int 			face_ct;		// ʐ
	D3DMATERIAL9	mtrl;			// }eA
	D3DXMATRIX		matrix; 		// s
	int				texture_index; 	// eNX`ԍ
}PARTS,*LPPARTS;

typedef struct{
	int 		flag;					// ]̎ށi0:ȂA1:Xw莲A2:xyzj
	float		roll_x,roll_y,roll_z;	// Xixj
	D3DXVECTOR3 v;						// XixNgj
	float		x,y,z;					// W
	D3DXMATRIX	matrix; 				// s
}UNIT,*LPUNIT;

typedef struct{
	float		roll[P_MAX][3]; // jbg]pxixj
	D3DXVECTOR3 pos[P_MAX]; 	// sړ
	D3DXVECTOR3 scale[P_MAX];	// gk
}MOTION,*LPMOTION;

typedef struct{
	int 		iStart;			// Jn[Vԍ
	int 		iEnd;			// I[Vԍ
	bool		bLoop;			// [v tO
	char		name[LEN_MAX];	// Aj
}ANIMSET;

class CFileECT
{
public:
	CFileECT();
	~CFileECT();
	// ECTt@C̓ǂݍ
	bool		Load( LPDIRECT3DDEVICE9 pD3DDev, char* strFilename, DWORD dwFVF = FVF_VERTEX_NT );
	// I
	void		Free();
	// Aj擾
	int 		GetAnimCount() {return m_m.anim_ct;}
	// wAjԍł̃[Vԍ͈͂擾
	ANIMSET 	GetAnimSet(int idxAnim);
	// AjAjԍ擾
	int 		GetAnimIndex(char *strAnimName);
	// [Vԍݒ
	void		SetMotionIndex(int idxMotion) {m_idx_mt = idxMotion;}
	// f tO擾
	DWORD		GetModelFlag() { return m_m.flag_model; }
	// SW擾
	D3DXVECTOR3	GetCenter() { return m_m.t_center; }
	// oEfBO{bNX̍W擾
	D3DXVECTOR3	GetMin() { return m_m.t_bbox_min; }
	// oEfBO{bNX̉EW擾
	D3DXVECTOR3	GetMax() { return m_m.t_bbox_max; }
	// bV IuWFNg擾
	LPD3DXMESH	GetMesh() { return m_m.pMesh; }
	// _tH[}bg擾
	DWORD		GetFVF() { return m_m.pMesh->GetFVF(); }
	// _tH[}bgύX
	HRESULT		SetFVF( LPDIRECT3DDEVICE9 pD3DDev, DWORD dwFVF );
	// `
	HRESULT 	Render( LPDIRECT3DDEVICE9 pD3DDev, bool bMaterial = true,
						bool bTexture = true );
	// p[c`
	HRESULT 	RenderParts( LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX matrix,
							int index, bool bMaterial = true, bool bTexture = true );
	// p[c`p[hsݒ
	void		SetMatrix();

private:
	MODEL	m_m;				// f
	LPPARTS m_pp;				// p[c
	LPUNIT	m_pun;				// jbg
	MOTION	m_mt[M_MAX];		// [V
	ANIMSET m_as[A_MAX];		// Aj
	int 	m_parents[P_MAX];	// jbgƃp[c̐ejbgԍ
	int 	m_idx_mt;			// ݑIĂ郂[Vԍ
	DWORD	m_dwFVF;			// _tH[}bg
	DWORD	m_dwSizeVERTEX; 	// _tH[}bg\̃TCY
	D3DXMATRIX	m_mat1; 		// Pʍs
	int 	(*m_pf)[4]; 		// eʂ̒_ԍi_3̂Ƃ m_pf[][3] = -1j
	char	m_strTexName[P_MAX][MAX_PATH];	// eNX`

private:
	D3DXMATRIX	GetMatrix(int idx);
	void		SetAxisSlant();
	bool		LoadFileEctTxt(LPDIRECT3DDEVICE9 pD3DDev, char *strFilename);
	bool		LoadFileEctBin(LPDIRECT3DDEVICE9 pD3DDev, char *strFilename);
	void		SetTextureName(char *strTexName, int p_ct);
	void		LoadTexture(LPDIRECT3DDEVICE9 pD3DDev, char *path);
	HRESULT 	LoadFileEctSub(LPDIRECT3DDEVICE9 pD3DDev, D3DXVECTOR3 *pv, float *pb,
								D3DXVECTOR3 *pn, float *ptu, float *ptv,
								int t_vtx_ct, int t_face_ct, char *path);
	void		Poly4To3(int &t_face_ct);
	HRESULT 	CreateMesh(LPDIRECT3DDEVICE9 pD3DDev, D3DXVECTOR3 *pv, float *pb,
							D3DXVECTOR3 *pn, float *ptu, float *ptv,
							int t_vtx_ct, int t_face_ct);
	void		FreeFileMemory(D3DXVECTOR3 *pv, float *pb, D3DXVECTOR3 *pn,
								float *ptu, float *ptv);
};

CFileECT::CFileECT()
{
	Free();
	m_pp	 = NULL;
	m_pun	 = NULL;
	m_idx_mt = 0;
	m_dwFVF  = 0;
	D3DXMatrixIdentity(&m_mat1);	// Pʍs쐬
}

CFileECT::~CFileECT()
{
	Free();
}

// ECTt@Cǂݍ
// strFilename : [IN] t@C
// dwFVF	   : [IN] _tH[}bgifvf.h ̒̂ꂩPj
bool CFileECT::Load( LPDIRECT3DDEVICE9 pD3DDev, char* strFilename, DWORD dwFVF )
{
	Free();
	m_dwFVF = dwFVF;
	if(!( LoadFileEctTxt(pD3DDev, strFilename) )){
		if(!( LoadFileEctBin(pD3DDev, strFilename) )){
			return 0;
		}
	}

	return 1;
}

// ̉
void CFileECT::Free()
{
	int i,j;
	
	//̈
	for(i=0; i<m_m.texture_ct; i++){
		SAFE_RELEASE(m_m.pTexture[i].pTex);
	}
	SAFE_DELETE_ARRAY(m_m.pTexture);
	SAFE_DELETE_ARRAY(m_pp);
	SAFE_DELETE_ARRAY(m_pun);
	SAFE_RELEASE(m_m.pMesh);
	
	ZeroMemory(&m_m, sizeof(m_m));
	ZeroMemory(m_mt, sizeof(m_mt));
	ZeroMemory(m_as, sizeof(m_as));
	ZeroMemory(m_parents, sizeof(m_parents));
	for(i=0; i<M_MAX; i++){
		for(j=0; j<P_MAX; j++){
			m_mt[i].scale[j] = D3DXVECTOR3(1,1,1);
		}
	}
	m_idx_mt = 0;
}

// wAjԍł̃[Vԍ͈͂擾
// idxAnim : [IN] Ajԍ
ANIMSET CFileECT::GetAnimSet(int idxAnim)
{
	ANIMSET as;
	
	if(m_m.anim_ct > 0){
		if(idxAnim >= 0 && idxAnim < m_m.anim_ct)
			as = m_as[idxAnim];
		else
			ZeroMemory(&as, sizeof(as));
	}
	else{
		as.iStart = 0;
		as.iEnd   = m_m.mt_ct - 1;
	}
	
	return as;
}

// AjAjԍ擾
int CFileECT::GetAnimIndex(char *strAnimName)
{
	int i,res = -1;
	for(i=0; i<m_m.anim_ct; i++){
		if(!stricmp(m_as[i].name, strAnimName)){
			res = i;
			break;
		}
	}
	return res;
}

// _tH[}bgύX
HRESULT CFileECT::SetFVF( LPDIRECT3DDEVICE9 pD3DDev, DWORD dwFVF )
{
	LPD3DXMESH pTempMesh  = NULL;

	if( m_m.pMesh ){
		if( FAILED( m_m.pMesh->CloneMeshFVF( 0L, dwFVF, pD3DDev, &pTempMesh ) ) ){
			return E_FAIL;
		}
	}

	SAFE_RELEASE( m_m.pMesh );

	if( pTempMesh )  m_m.pMesh  = pTempMesh;

	// Compute normals in case the meshes have them
	if( m_m.pMesh )
		D3DXComputeNormals( m_m.pMesh, NULL );

	return S_OK;
}

// bV`
// pD3DDev	 : [IN] IDirect3DDevice9 IuWFNg
// bMaterial : [IN] }eAKptO
// bTexture  : [IN] eLX`KptO
HRESULT CFileECT::Render( LPDIRECT3DDEVICE9 pD3DDev, bool bMaterial, bool bTexture )
{
	if(!pD3DDev)
		return E_FAIL;
	
	HRESULT 				hr;
	DWORD					dwLighting_pre,dwVB_pre;
	DWORD					dwEnableAlpha_pre,dwSrcAlpha_pre,dwDestAlpha_pre;
	DWORD					dwWrap_pre;
	D3DXMATRIX				mat1_pre,mat2_pre;
	int 					i;
	
	hr = pD3DDev->GetRenderState(D3DRS_LIGHTING, &dwLighting_pre);
	hr = pD3DDev->GetRenderState(D3DRS_WRAP0, &dwWrap_pre);
	hr = pD3DDev->GetRenderState(D3DRS_VERTEXBLEND, &dwVB_pre);
	hr = pD3DDev->GetRenderState(D3DRS_ALPHABLENDENABLE, &dwEnableAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_SRCBLEND,  &dwSrcAlpha_pre);
	hr = pD3DDev->GetRenderState(D3DRS_DESTBLEND, &dwDestAlpha_pre);
	hr = pD3DDev->GetTransform(D3DTS_WORLDMATRIX(0), &mat1_pre);
	hr = pD3DDev->GetTransform(D3DTS_WORLDMATRIX(1), &mat2_pre);
	
	if(!(m_dwFVF & D3DFVF_NORMAL)){ // _@Ȃꍇ
		hr = pD3DDev->SetRenderState(D3DRS_LIGHTING, FALSE);
	}
	
	// WIgufBOL
	if(m_m.flag_model & MODEL_SKIN){	// XL̏ꍇ
		hr = pD3DDev->SetRenderState(D3DRS_VERTEXBLEND, D3DVBF_1WEIGHTS);
		if(FAILED(hr))
			return hr;
	}
	
	SetMatrix();	// jbgsݒ
	
	// Frist, draw the subsets without alpha
	for(i=0; i<m_m.parts_ct; i++){
		if( m_pp[i].mtrl.Diffuse.a < 1.0f )
			continue;
		RenderParts(pD3DDev, mat1_pre, i, bMaterial, bTexture);
	}
	
	// Then, draw the subsets with alpha
	for(i=0; i<m_m.parts_ct; i++){
		if( m_pp[i].mtrl.Diffuse.a == 1.0f )
			continue;
		RenderParts(pD3DDev, mat1_pre, i, bMaterial, bTexture);
	}
	
	// ݒɖ߂
	hr = pD3DDev->SetRenderState(D3DRS_LIGHTING, dwLighting_pre);
	hr = pD3DDev->SetRenderState(D3DRS_WRAP0, dwWrap_pre);
	hr = pD3DDev->SetRenderState(D3DRS_VERTEXBLEND, dwVB_pre);
	hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, dwEnableAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,  dwSrcAlpha_pre);
	hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND, dwDestAlpha_pre);
	hr = pD3DDev->SetTransform(D3DTS_WORLDMATRIX(0), &mat1_pre);
	hr = pD3DDev->SetTransform(D3DTS_WORLDMATRIX(1), &mat2_pre);

	return hr;
}

// p[c bV`
// pD3DDev	 : [IN] IDirect3DDevice9 IuWFNg
// matrix	 : [IN] fŜ̃[hs
// index	 : [IN] p[cԍ
// bMaterial : [IN] }eAKptO
// bTexture  : [IN] eLX`KptO
HRESULT CFileECT::RenderParts( LPDIRECT3DDEVICE9 pD3DDev, D3DXMATRIX matrix,
								int index, bool bMaterial, bool bTexture )
{
	if(!pD3DDev  || !m_m.pMesh)
		return E_FAIL;
	
	HRESULT 	hr;
	D3DXMATRIX	mat_ax;
	int			idxTexPre = -1;
	
	// eNX` ufBOݒ
	switch(m_pp[index].flag_alpha)
	{
	case ALPHA_NONE:
		hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
		break;
	case ALPHA_HALF:
		hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
		hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA);
		hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
		break;
	case ALPHA_ADD:
		hr = pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
		hr = pD3DDev->SetRenderState(D3DRS_SRCBLEND,  D3DBLEND_ONE);
		hr = pD3DDev->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
		break;
	}
	
	if(m_pp[index].flag_wrap == 2)		// UeNX`bsOL
		hr = pD3DDev->SetRenderState(D3DRS_WRAP0, D3DWRAP_U);
	else								// eNX`bsO
		hr = pD3DDev->SetRenderState(D3DRS_WRAP0, 0);
	if(bMaterial && (m_dwFVF & D3DFVF_NORMAL)){ // }eAKptOƒ_@ꍇ
		hr = pD3DDev->SetMaterial(&m_pp[index].mtrl);	// }eAKp
	}
	if(bTexture){
		int	idxTex = m_pp[index].texture_index;
		if(!m_m.pTexture[idxTex].pTex || !(m_dwFVF & D3DFVF_TEX1)){
			hr = pD3DDev->SetTexture(0, NULL);	// eNX`
		}
		else if(idxTex != idxTexPre){
			hr = pD3DDev->SetTexture(0, m_m.pTexture[idxTex].pTex);	// eNX`Kp
			idxTexPre = idxTex;
		}
	}
	if(m_m.flag_model & MODEL_SKIN){	// XL̏ꍇ
		// ejbg̉]s
		if(m_parents[index] < m_m.parts_ct){	// ejbgȂƂ
			mat_ax = m_mat1;
		}
		else{									// ejbgƂ
			mat_ax = m_pun[m_parents[index] - m_m.parts_ct].matrix;
		}
		mat_ax				*= matrix;
		m_pp[index].matrix	*= matrix;
		hr = pD3DDev->SetTransform(D3DTS_WORLDMATRIX(0), &mat_ax);
		// p[c̉]s
		hr = pD3DDev->SetTransform(D3DTS_WORLDMATRIX(1), &m_pp[index].matrix);
		hr = m_m.pMesh->DrawSubset(index);
	}
	else{
		if(m_m.mt_ct > 1){
			hr = pD3DDev->SetTransform(D3DTS_WORLD, &(m_pp[index].matrix * matrix));
		}
		else{
			hr = pD3DDev->SetTransform(D3DTS_WORLD, &matrix);
		}
		hr = m_m.pMesh->DrawSubset(index);
	}
	
	return hr;
}

// jbgsݒ肷
void CFileECT::SetMatrix()
{
	int 		i,idx_parent,ct;
	D3DXMATRIX	matrix;
	
	if(m_m.flag_model & MODEL_SKIN){	// XL̏ꍇ
		for(i=0; i<m_m.parts_ct+m_m.unit_ct; i++){
			if(i < m_m.parts_ct)
				m_pp[i].matrix = m_mat1;
			else
				m_pun[i-m_m.parts_ct].matrix = m_mat1;
			idx_parent = m_parents[i];
			ct = 0;
			while(idx_parent >= m_m.parts_ct && idx_parent < (m_m.parts_ct + m_m.unit_ct)){
				matrix = GetMatrix(idx_parent-m_m.parts_ct);	// jbgs擾
				if(i < m_m.parts_ct)	// p[cs
					m_pp[i].matrix *= matrix;
				else					// jbgs
					m_pun[i-m_m.parts_ct].matrix *= matrix;
				idx_parent = m_parents[idx_parent];
				ct ++;
				if(ct > P_MAX)	break;
			}
		}
	}
	else{	// XLł͂Ȃꍇ
		for(i=0;i<m_m.parts_ct;i++){
			m_pp[i].matrix = m_mat1;
			idx_parent = m_parents[i];
			ct = 0;
			while(idx_parent > 0){
				matrix = GetMatrix(idx_parent-m_m.parts_ct);	// jbgs擾
				m_pp[i].matrix *= matrix;	// p[cs
				idx_parent = m_parents[idx_parent];
				ct ++;
				if(ct > P_MAX)	break;
			}
		}
	}
}// SetMatrix

// jbgs擾
D3DXMATRIX CFileECT::GetMatrix(int idx)
{
	D3DXMATRIX	matT1,matT2,matS,matR,matRX,matRY,matRZ,matrix;
	
	D3DXMatrixTranslation(&matT1,-m_pun[idx].x,-m_pun[idx].y,-m_pun[idx].z);
	D3DXMatrixTranslation(&matT2, m_pun[idx].x + m_mt[m_idx_mt].pos[idx].x,
								  m_pun[idx].y + m_mt[m_idx_mt].pos[idx].y,
								  m_pun[idx].z + m_mt[m_idx_mt].pos[idx].z);
	D3DXMatrixScaling(&matS, m_mt[m_idx_mt].scale[idx].x, m_mt[m_idx_mt].scale[idx].y, m_mt[m_idx_mt].scale[idx].z);
	if(m_pun[idx].flag == 1){
		D3DXMatrixRotationAxis(&matR, &m_pun[idx].v, m_mt[m_idx_mt].roll[idx][0]);
		matrix = matT1 * matS * matR * matT2;
	}
	else{
		D3DXMatrixRotationX(&matRX, (float)m_mt[m_idx_mt].roll[idx][0]);
		D3DXMatrixRotationY(&matRY, (float)m_mt[m_idx_mt].roll[idx][1]);
		D3DXMatrixRotationZ(&matRZ, (float)m_mt[m_idx_mt].roll[idx][2]);
		matrix = matT1 * matS * matRX * matRY * matRZ * matT2;
	}
	
	return matrix;
}// GetMatrix

// ]̌XixNgj߂
void CFileECT::SetAxisSlant()
{
	D3DXMATRIX	mat,matRX,matRY,matRZ;
	int i;
	for(i=0; i<m_m.unit_ct; i++){
		D3DXMatrixRotationX(&matRX, (float) m_pun[i].roll_x);
		D3DXMatrixRotationY(&matRY, (float) m_pun[i].roll_y);
		D3DXMatrixRotationZ(&matRZ, (float) m_pun[i].roll_z);
		mat = matRX * matRY * matRZ;
		D3DXVec3TransformCoord(&m_pun[i].v, &D3DXVECTOR3(1,0,0), &mat);
	}
}// SetAxisSlant

// ECTt@C̓ǂݍ݁ieLXg`j
bool CFileECT::LoadFileEctTxt(LPDIRECT3DDEVICE9 pD3DDev, char *strFilename)
{
	if(!pD3DDev)
		return false;
	
	FILE	*file1;
	
	char		ss[256],path[MAX_PATH],*p;
	int 		i,flag = 0;
	int 		p_ct = 0,ct1 = 0,ct2 = 0,ct3 = 0,ct4 = 0,ct5 = 0,ct6 = 0,ct7 = 0,ct8 = 0,ct9 = 0,ct10 = 0,ct11 = 0;
	int 		t_vtx_ct;	// _
	int 		t_face_ct;	// ʐ
	D3DXVECTOR3 *pv;		// _W
	float		*pb;		// uh̏d
	D3DXVECTOR3 *pn;		// _@xNg
	float		*ptu,*ptv;	// _eNX`W
	
	strcpy(path, strFilename);
	p = strrchr(path,'\\');
	if(p)
		*(p+1) = '\0';
	else
		strcpy(path, "");
	
	if((file1=fopen(strFilename,"r")) == NULL){
		return 0;		
	}
	
	while(!feof(file1)){
		
		fgets(ss,256,file1);
		if(ss[strlen(ss)-1] == '\n'){
			ss[strlen(ss)-1] = '\0';
		}
		
		// f tO
		if(!strcmp(ss,"<flag_model>")){
			flag = 1;
		}
		else if(!strcmp(ss,"</flag_model>")){
			flag = 0;
		}
		else if(flag == 1){
			sscanf(ss,"%d",&m_m.flag_model);
		}
		
		// p[c
		else if(!strcmp(ss,"<parts_count>")){
			flag = 2;
		}
		else if(!strcmp(ss,"</parts_count>")){
			flag = 0;
		}
		else if(flag == 2){
			sscanf(ss,"%d",&m_m.parts_ct);
			if(m_m.parts_ct >= P_MAX){
				fclose(file1);
				return 0;
			}
			m_pp = new PARTS [m_m.parts_ct+1];
			for(i=0; i<m_m.parts_ct; i++){
				m_pp[i].vtx_ct = 0;
				m_pp[i].face_ct = 0;
			}
		}
		
		// [V
		else if(!strcmp(ss,"<motion_count>")){
			flag = 3;
		}
		else if(!strcmp(ss,"</motion_count>")){
			flag = 0;
		}
		else if(flag == 3){
			sscanf(ss,"%d",&m_m.mt_ct);
			if(m_m.mt_ct >= M_MAX){
				fclose(file1);
				return 0;
			}
		}
		
		// jbg
		else if(!strcmp(ss,"<unit_count>")){
			flag = 4;
		}
		else if(!strcmp(ss,"</unit_count>")){
			flag = 0;
		}
		else if(flag == 4){
			sscanf(ss,"%d",&m_m.unit_ct);
			if(m_m.unit_ct >= P_MAX){
				fclose(file1);
				return 0;
			}
			m_pun = new UNIT [m_m.unit_ct];
		}
		
		// IuWFNgŜ̒_W
		else if(!strcmp(ss,"<total_vertex_count>")){
			flag = 5;
		}
		else if(!strcmp(ss,"</total_vertex_count>")){
			flag = 0;
		}
		else if(flag == 5){
			sscanf(ss,"%d",&t_vtx_ct);
			pv	= new D3DXVECTOR3 [t_vtx_ct];
			pb	= new float 	  [t_vtx_ct];
			pn	= new D3DXVECTOR3 [t_vtx_ct];
			ptu = new float 	  [t_vtx_ct];
			ptv = new float 	  [t_vtx_ct];
			ZeroMemory(pb, t_vtx_ct * sizeof(float));
			ZeroMemory(ptu, t_vtx_ct * sizeof(float));
			ZeroMemory(ptv, t_vtx_ct * sizeof(float));
		}
		
		// IuWFNgŜ̖ʐ
		else if(!strcmp(ss,"<total_face_count>")){
			flag = 6;
		}
		else if(!strcmp(ss,"</total_face_count>")){
			flag = 0;
		}
		else if(flag == 6){
			sscanf(ss,"%d",&t_face_ct);
			m_pf = new int [t_face_ct][4];
		}
		
		// IuWFNgŜ̃oEfBO{bNX̍ŏl
		else if(!strcmp(ss,"<total_corner_min>")){
			flag = 7;
		}
		else if(!strcmp(ss,"</total_corner_min>")){
			flag = 0;
		}
		else if(flag == 7){
			sscanf(ss,"%f %f %f", &m_m.t_bbox_min.x, &m_m.t_bbox_min.y, &m_m.t_bbox_min.z);
		}
		
		// IuWFNgŜ̃oEfBO{bNX̍ől
		else if(!strcmp(ss,"<total_corner_max>")){
			flag = 8;
		}
		else if(!strcmp(ss,"</total_corner_max>")){
			flag = 0;
		}
		else if(flag == 8){
			sscanf(ss,"%f %f %f", &m_m.t_bbox_max.x, &m_m.t_bbox_max.y, &m_m.t_bbox_max.z);
		}
		
		// IuWFNgŜ̒S_
		else if(!strcmp(ss,"<total_center>")){
			flag = 9;
		}
		else if(!strcmp(ss,"</total_center>")){
			flag = 0;
		}
		else if(flag == 9){
			sscanf(ss,"%f %f %f", &m_m.t_center.x, &m_m.t_center.y, &m_m.t_center.z);
		}
		
		// p[cƂ̃fBt[YF
		else if(!strcmp(ss,"<diffuse>")){
			flag = 10;
		}
		else if(!strcmp(ss,"</diffuse>")){
			flag = 0;
		}
		else if(flag == 10){
			sscanf(ss,"%f %f %f %f", &m_pp[p_ct].mtrl.Diffuse.a, &m_pp[p_ct].mtrl.Diffuse.r, &m_pp[p_ct].mtrl.Diffuse.g, &m_pp[p_ct].mtrl.Diffuse.b);
			m_pp[p_ct].mtrl.Ambient = m_pp[p_ct].mtrl.Diffuse;
		}
		
		// p[cƂ̃XyLF
		else if(!strcmp(ss,"<specular>")){
			flag = 11;
		}
		else if(!strcmp(ss,"</specular>")){
			flag = 0;
		}
		else if(flag == 11){
			sscanf(ss,"%f %f %f %f",&m_pp[p_ct].mtrl.Specular.a,&m_pp[p_ct].mtrl.Specular.r,&m_pp[p_ct].mtrl.Specular.g,&m_pp[p_ct].mtrl.Specular.b);
		}
		
		// p[cƂ̃G~bVF
		else if(!strcmp(ss,"<emission>")){
			flag = 12;
		}
		else if(!strcmp(ss,"</emission>")){
			flag = 0;
		}
		else if(flag == 12){
			sscanf(ss,"%f %f %f %f",&m_pp[p_ct].mtrl.Emissive.a,&m_pp[p_ct].mtrl.Emissive.r,&m_pp[p_ct].mtrl.Emissive.g,&m_pp[p_ct].mtrl.Emissive.b);
		}
		
		// XyLFx
		else if(!strcmp(ss,"<specular_power>")){
			flag = 13;
		}
		else if(!strcmp(ss,"</specular_power>")){
			flag = 0;
		}
		else if(flag == 13){
			sscanf(ss,"%f",&m_pp[p_ct].mtrl.Power);
		}
		
		// eNX`t@C
		else if(!strcmp(ss,"<texture_file>")){
			flag = 14;
		}
		else if(!strcmp(ss,"</texture_file>")){
			flag = 0;
		}
		else if(flag == 14){
			SetTextureName(ss, p_ct);
		}
		
		// eNX`}bsOtO
		else if(!strcmp(ss,"<texture_map_flag>")){
			flag = 15;
		}
		else if(!strcmp(ss,"</texture_map_flag>")){
			flag = 0;
		}
		else if(flag == 15){
			sscanf(ss,"%d",&m_pp[p_ct].flag_wrap);
		}
		
		// At@ ufBO tO
		else if(!strcmp(ss,"<alpha_flag>")){
			flag = 16;
		}
		else if(!strcmp(ss,"</alpha_flag>")){
			flag = 0;
		}
		else if(flag == 16){
			sscanf(ss,"%d",&m_pp[p_ct].flag_alpha);
		}
		
		// ǂݍ񂾃p[c
		else if(!strcmp(ss,"</polygon_mesh>")){
			p_ct ++;
		}
		
		// p[cƂ̒_W
		else if(!strcmp(ss,"<vertices>")){
			flag = 17;
		}
		else if(!strcmp(ss,"</vertices>")){
			flag = 0;
			m_pp[p_ct + 1].vtx_ct = ct1;
		}
		else if(flag == 17){
			sscanf(ss,"%f %f %f %f %f %f %f %f %f",
				&pv[ct1].x,&pv[ct1].y,&pv[ct1].z,&pn[ct1].x,
				&pn[ct1].y,&pn[ct1].z,&ptu[ct1],&ptv[ct1],&pb[ct1]);
			ct1 ++;
		}
		
		// p[cƂ̖ʂ\钸_Wԍ
		else if(!strcmp(ss,"<faces>")){
			flag = 18;
		}
		else if(!strcmp(ss,"</faces>")){
			flag = 0;
			m_pp[p_ct + 1].face_ct = ct2;
		}
		else if(flag == 18){
			sscanf(ss,"%d %d %d %d",&m_pf[ct2][0],&m_pf[ct2][1],&m_pf[ct2][2],&m_pf[ct2][3]);
			ct2 ++;
		}
		
		// jbg{
		else if(!strcmp(ss,"<basis>")){
			flag = 19;
			ct3 = 0;
		}
		else if(!strcmp(ss,"</basis>")){
			flag = 0;
		}
		else if(flag == 19){
			if(ss[0] == '1'){
				int roll_x,roll_y,roll_z;
				sscanf(ss,"%d %f %f %f %d %d %d",&m_pun[ct3].flag,&m_pun[ct3].x,&m_pun[ct3].y,&m_pun[ct3].z,&roll_x,&roll_y,&roll_z);
				m_pun[ct3].roll_x = roll_x * D3DX_PI / 180;
				m_pun[ct3].roll_y = roll_y * D3DX_PI / 180;
				m_pun[ct3].roll_z = roll_z * D3DX_PI / 180;
			}
			else{
				sscanf(ss,"%d %f %f %f",&m_pun[ct3].flag,&m_pun[ct3].x,&m_pun[ct3].y,&m_pun[ct3].z);
			}
			ct3 ++;
		}
		
		// eԍ
		else if(!strcmp(ss,"<parent>")){
			flag = 20;
			ct4 = 0;
		}
		else if(!strcmp(ss,"</parent>")){
			flag = 0;
		}
		else if(flag == 20){
			sscanf(ss,"%d",&m_parents[ct4]);
			ct4 ++;
		}
		
		// ֐ߊpx
		else if(!strcmp(ss,"<angle>")){
			flag = 21;
			ct5 = 0;
		}
		else if(!strcmp(ss,"</angle>")){
			flag = 0;
			ct6 ++;
		}
		else if(flag == 21){
			int roll[3];
			if(m_pun[ct5].flag == 1){
				sscanf(ss,"%d",&roll[0]);
				m_mt[ct6].roll[ct5][0] = roll[0] * D3DX_PI / 180;
			}
			else{
				sscanf(ss,"%d %d %d",&roll[0],&roll[1],&roll[2]);
				for(i=0; i<3; i++){
					m_mt[ct6].roll[ct5][i] = roll[i] * D3DX_PI / 180;
				}
			}
			ct5 ++;
		}
		
		// sړ
		else if(!strcmp(ss,"<translation>")){
			flag = 22;
			ct7 = 0;
		}
		else if(!strcmp(ss,"</translation>")){
			flag = 0;
			ct8 ++;
		}
		else if(flag == 22){
			sscanf(ss,"%f %f %f",&m_mt[ct8].pos[ct7].x,&m_mt[ct8].pos[ct7].y,&m_mt[ct8].pos[ct7].z);
			ct7 ++;
		}
		
		// gk
		else if(!strcmp(ss,"<scale>")){
			flag = 23;
			ct9 = 0;
		}
		else if(!strcmp(ss,"</scale>")){
			flag = 0;
			ct10 ++;
		}
		else if(flag == 23){
			sscanf(ss,"%f %f %f",&m_mt[ct10].scale[ct9].x,&m_mt[ct10].scale[ct9].y,&m_mt[ct10].scale[ct9].z);
			ct9 ++;
		}
		
		// Aj
		else if(!strcmp(ss,"<anim_count>")){
			flag = 24;
		}
		else if(!strcmp(ss,"</anim_count>")){
			flag = 0;
		}
		else if(flag == 24){
			sscanf(ss,"%d",&m_m.anim_ct);
			if(m_m.anim_ct >= A_MAX)
				m_m.anim_ct = A_MAX - 1;
		}
		
		// Aj f[^
		else if(!strcmp(ss,"<anim_data>")){
			flag = 25;
			ct11 = 0;
		}
		else if(!strcmp(ss,"</anim_data>")){
			flag = 0;
		}
		else if(flag == 25){
			sscanf(ss,"%d %d %d %s", &m_as[ct11].iStart, &m_as[ct11].iEnd, &m_as[ct11].bLoop, &m_as[ct11].name);
			ct11 ++;
		}
	}
	
	fclose(file1);
	
	if(!LoadFileEctSub(pD3DDev, pv, pb, pn, ptu, ptv, t_vtx_ct, t_face_ct, path))
		return 0;
	
	return 1;
}// LoadFileEctTxt

// ECTt@C̓ǂݍ݁ioCi`j
bool CFileECT::LoadFileEctBin(LPDIRECT3DDEVICE9 pD3DDev, char *strFilename)
{
	if(!pD3DDev)
		return false;
	
	FILE		*file1;
	int 		i,j,k,len,tg,tag_num;
	UINT		len_tag,size;
	char		tag[TAG_LEN],path[MAX_PATH],type[4],*p;
	int 		t_vtx_ct;	// _
	int 		t_face_ct;	// ʐ
	D3DXVECTOR3 *pv;		// _W
	float		*pb;		// uh̏d
	D3DXVECTOR3 *pn;		// _@xNg
	float		*ptu,*ptv;	// _eNX`W
	char		tag_list[][TAG_LEN] = 
					{"flag_model","parts_count","motion_count","unit_count","total_vertex_count",
					"total_face_count","total_corner","total_center","material","texture_file",
					"texture_map_flag","alpha_flag","vertex_count","face_count","vertices",
					"normals","texture_map","faces","unit_basis","parent","unit_angle",
					"unit_translation","unit_scale","blend","anim_count","anim_data"};
	
	strcpy(path, strFilename);
	p = strrchr(path,'\\');
	if(p)
		*(p+1) = '\0';
	else
		strcpy(path, "");
	
	if((file1=fopen(strFilename,"rb")) == NULL){
		return 0;
	}
	
	fread(type,sizeof(char),4,file1);
	if(strcmp(type, "ECT")){
		fclose(file1);
		return 0;
	}
	fread(&tag_num,sizeof(int),1,file1);
	for(tg=0; tg<tag_num; tg++){
		int read_size = fread(&len_tag,sizeof(int),1,file1);
		if(read_size<1){
			break;
		}
		if(len_tag > sizeof(tag))	len_tag = sizeof(tag);
		fread(tag,sizeof(char),len_tag,file1);
		fread(&size,sizeof(int),1,file1);
		bool flag = false;
		for(k=0; k<sizeof(tag_list)/sizeof(tag_list[0]); k++){
			if(!strcmp(tag, tag_list[k])){
				flag = true;
switch(k)
{
case 0:
	fread(&m_m.flag_model,sizeof(DWORD),1,file1);
	break;
case 1:
	fread(&m_m.parts_ct,sizeof(int),1,file1);
	if(m_m.parts_ct >= P_MAX){
		fclose(file1);
		return 0;
	}
	m_pp = new PARTS [m_m.parts_ct+1];
	ZeroMemory(m_pp,sizeof(PARTS)*(m_m.parts_ct+1));
	for(i=0; i<m_m.parts_ct; i++){
		m_pp[i].vtx_ct = 0;
		m_pp[i].face_ct = 0;
		m_pp[i].mtrl.Diffuse.a = 1.0f;
		m_pp[i].mtrl.Diffuse.r = 0.8f;
		m_pp[i].mtrl.Diffuse.g = 0.8f;
		m_pp[i].mtrl.Diffuse.b = 0.8f;
		m_pp[i].mtrl.Ambient = m_pp[i].mtrl.Diffuse;
	}
	break;
case 2:
	fread(&m_m.mt_ct,sizeof(int),1,file1);
	if(m_m.mt_ct >= M_MAX)
		m_m.mt_ct = M_MAX - 1;
	break;
case 3:
	fread(&m_m.unit_ct,sizeof(int),1,file1);
	if(m_m.unit_ct >= P_MAX)
		m_m.unit_ct = P_MAX - 1;
	m_pun = new UNIT [m_m.unit_ct];
	break;
case 4:
	fread(&t_vtx_ct,sizeof(int),1,file1);
	pv	= new D3DXVECTOR3 [t_vtx_ct];
	pb	= new float 	  [t_vtx_ct];
	pn	= new D3DXVECTOR3 [t_vtx_ct];
	ptu = new float 	  [t_vtx_ct];
	ptv = new float 	  [t_vtx_ct];
	ZeroMemory(ptu, t_vtx_ct * sizeof(float));
	ZeroMemory(ptv, t_vtx_ct * sizeof(float));
	break;
case 5:
	fread(&t_face_ct,sizeof(int),1,file1);
	m_pf = new int [t_face_ct][4];
	break;
case 6:
	fread(&m_m.t_bbox_min,sizeof(D3DXVECTOR3),1,file1);
	fread(&m_m.t_bbox_max,sizeof(D3DXVECTOR3),1,file1);
	break;
case 7:
	fread(&m_m.t_center,sizeof(D3DXVECTOR3),1,file1);
	break;
case 8:
	for(i=0; i<m_m.parts_ct; i++)
		fread(&m_pp[i].mtrl,sizeof(D3DMATERIAL9),1,file1);
	break;
case 9:
	for(i=0; i<m_m.parts_ct; i++){
		fread(&len,sizeof(int),1,file1);
		char strTexName[MAX_PATH];
		fread(strTexName,sizeof(char),len,file1);
		SetTextureName(strTexName, i);
	}
	break;
case 10:
	for(i=0; i<m_m.parts_ct; i++)
		fread(&m_pp[i].flag_wrap,sizeof(int),1,file1);
	break;
case 11:
	for(i=0;i<m_m.parts_ct;i++){
		fread(&m_pp[i].flag_alpha,sizeof(DWORD),1,file1);
	}
	break;
case 12:
	for(i=0; i<m_m.parts_ct; i++){
		fread(&m_pp[i+1].vtx_ct,sizeof(int),1,file1);
		m_pp[i+1].vtx_ct += m_pp[i].vtx_ct;
	}
	break;
case 13:
	for(i=0; i<m_m.parts_ct; i++){
		fread(&m_pp[i+1].face_ct,sizeof(int),1,file1);
		m_pp[i+1].face_ct += m_pp[i].face_ct;
	}
	break;
case 14:
	fread(pv,sizeof(D3DXVECTOR3),t_vtx_ct,file1);
	break;
case 15:
	fread(pn,sizeof(D3DXVECTOR3),t_vtx_ct,file1);
	break;
case 16:
	for(i=0; i<t_vtx_ct; i++){
		fread(&ptu[i],sizeof(float),1,file1);
		fread(&ptv[i],sizeof(float),1,file1);
	}
	break;
case 17:
	fread(m_pf,sizeof(int[4]),t_face_ct,file1);
	break;
case 18:
	for(i=0; i<m_m.unit_ct; i++){
		fread(&m_pun[i].flag,sizeof(int),1,file1);
		fread(&m_pun[i].x,sizeof(float),1,file1);
		fread(&m_pun[i].y,sizeof(float),1,file1);
		fread(&m_pun[i].z,sizeof(float),1,file1);
		if(m_pun[i].flag == 1){
			int roll_x,roll_y,roll_z;
			fread(&roll_x,sizeof(int),1,file1);
			fread(&roll_y,sizeof(int),1,file1);
			fread(&roll_z,sizeof(int),1,file1);
			m_pun[i].roll_x = roll_x * (D3DX_PI / 180);
			m_pun[i].roll_y = roll_y * (D3DX_PI / 180);
			m_pun[i].roll_z = roll_z * (D3DX_PI / 180);
		}
		fread(&len,sizeof(int),1,file1);
		fseek(file1, len, SEEK_CUR);	// ǂݔ΂
	}
	break;
case 19:
	fread(m_parents,sizeof(int),m_m.parts_ct+m_m.unit_ct,file1);
	break;
case 20:
	for(i=0; i<m_m.mt_ct; i++){
		for(j=0; j<m_m.unit_ct; j++){
			int roll[3];
			fread(&roll[0],sizeof(int),1,file1);
			m_mt[i].roll[j][0] = roll[0] * D3DX_PI / 180;
			if(m_pun[j].flag == 2){
				fread(&roll[1],sizeof(int),1,file1);
				fread(&roll[2],sizeof(int),1,file1);
				m_mt[i].roll[j][1] = roll[1] * D3DX_PI / 180;
				m_mt[i].roll[j][2] = roll[2] * D3DX_PI / 180;
			}
		}
	}
	break;
case 21:
	for(i=0; i<m_m.mt_ct; i++){
		for(j=0;j<m_m.unit_ct;j++){
			fread(&m_mt[i].pos[j],sizeof(D3DXVECTOR3),1,file1);
		}
	}
	break;
case 22:
	for(i=0; i<m_m.mt_ct; i++){
		for(j=0; j<m_m.unit_ct; j++){
			fread(&m_mt[i].scale[j],sizeof(D3DXVECTOR3),1,file1);
		}
	}
	break;
case 23:
	fread(pb,sizeof(float),t_vtx_ct,file1);
	break;
case 24:
	fread(&m_m.anim_ct,sizeof(int),1,file1);
	if(m_m.anim_ct >= A_MAX)
		m_m.anim_ct = A_MAX - 1;
	break;
case 25:
	for(i=0; i<m_m.anim_ct; i++){
		fread(&m_as[i].iStart,sizeof(int),1,file1);
		fread(&m_as[i].iEnd,sizeof(int),1,file1);
		fread(&m_as[i].bLoop,sizeof(bool),1,file1);
		fread(&len,sizeof(int),1,file1);
		fread(&m_as[i].name,sizeof(char),len,file1);
	}
	break;
}
				break;
			}
		}
		if(!flag)
			fseek(file1, size, SEEK_CUR);	// ǂݔ΂
	}
	
	if(fclose(file1)){
		FreeFileMemory(pv, pb, pn, ptu, ptv);
		return 0;
	}
	
	if(!LoadFileEctSub(pD3DDev, pv, pb, pn, ptu, ptv, t_vtx_ct, t_face_ct, path))
		return 0;
	
	return 1;
}// LoadFileEctBin

// eNX`ݒ
void CFileECT::SetTextureName(char *strTexName, int p_ct)
{
	int		i;
	bool	flag = false;
	for(i=0; i<m_m.texture_ct; i++){
		if(!strcmp(strTexName, m_strTexName[i])){
			m_pp[p_ct].texture_index = i;
			flag = true;
			break;
		}
	}
	if(!flag){
		strcpy(m_strTexName[m_m.texture_ct], strTexName);
		m_pp[p_ct].texture_index = m_m.texture_ct;
		m_m.texture_ct ++;
	}
}// SetTextureName

// eNX`ǂݍ
void CFileECT::LoadTexture(LPDIRECT3DDEVICE9 pD3DDev, char *path)
{
	int		i;
	char	strTexName[MAX_PATH];
	
	m_m.pTexture = new TEXTURE [m_m.texture_ct];
	
	if(m_m.pTexture){
		for(i=0; i<m_m.texture_ct; i++){
			sprintf(strTexName,"%s%s", path, m_strTexName[i]);
			if(FAILED(D3DXCreateTextureFromFile(pD3DDev, strTexName, &m_m.pTexture[i].pTex))){
				m_m.pTexture[i].pTex = NULL;
			}
		}
	}
}// LoadTexture

HRESULT CFileECT::LoadFileEctSub(LPDIRECT3DDEVICE9 pD3DDev, D3DXVECTOR3 *pv, float *pb,
								D3DXVECTOR3 *pn, float *ptu, float *ptv,
								int t_vtx_ct, int t_face_ct, char *path)
{
	if(!m_m.parts_ct || !t_vtx_ct || !t_face_ct)
		return 0;
	
	if(!(m_m.flag_model & MODEL_3VERTEX)){
		Poly4To3(t_face_ct);
	}
	HRESULT hr;
	hr = CreateMesh(pD3DDev, pv, pb, pn, ptu, ptv, t_vtx_ct, t_face_ct);
	FreeFileMemory(pv, pb, pn, ptu, ptv);
	if(m_m.unit_ct){
		SetAxisSlant(); // ]̌XixNgj߂
	}
	// eNX`ǂݍ
	LoadTexture(pD3DDev, path);
	
	return hr;
}// LoadFileEctSub

// lp`|SOp`ɕϊ
void CFileECT::Poly4To3(int &t_face_ct)
{
	int (*pf2)[3],*f_n;
	int i,j,ct;
	pf2 = new int [t_face_ct*2][3];
	f_n = new int [m_m.parts_ct+1];
	ZeroMemory(pf2, sizeof(int[3])*t_face_ct*2);
	ZeroMemory(f_n, sizeof(int)*(m_m.parts_ct+1));
	ct = 0;
	for(i=0;i<m_m.parts_ct;i++){
		for(j=m_pp[i].face_ct;j<m_pp[i+1].face_ct;j++){
			pf2[ct][0] = m_pf[j][0];
			pf2[ct][1] = m_pf[j][1];
			pf2[ct][2] = m_pf[j][2];
			ct ++;
			if(m_pf[j][3] != -1){
				pf2[ct][0] = m_pf[j][0];
				pf2[ct][1] = m_pf[j][2];
				pf2[ct][2] = m_pf[j][3];
				ct ++;
			}
		}
		f_n[i+1] = ct;
	}
	for(i=0;i<m_m.parts_ct+1;i++){
		m_pp[i].face_ct = f_n[i];
	}
	SAFE_DELETE_ARRAY(m_pf);
	t_face_ct = ct;
	m_pf = new int [t_face_ct][4];
	for(i=0;i<t_face_ct;i++){
		for(j=0;j<3;j++){
			m_pf[i][j] = pf2[i][j];
		}
		m_pf[i][3] = -1;
	}
	SAFE_DELETE_ARRAY(pf2);
	SAFE_DELETE_ARRAY(f_n);
}// Poly4To3

// XbVIuWFNg쐬
HRESULT CFileECT::CreateMesh(LPDIRECT3DDEVICE9 pD3DDev, D3DXVECTOR3 *pv, float *pb,
							D3DXVECTOR3 *pn, float *ptu, float *ptv,
							int t_vtx_ct, int t_face_ct)
{
	HRESULT 			hr;
	BYTE				*pBuf = NULL;
	WORD				*pBuf2 = NULL;
	DWORD				*pBuf3 = NULL;
	D3DXATTRIBUTERANGE	*pAttr = NULL;
	int 				i,j;
	
	// bVIuWFNg̍쐬
		m_dwFVF &= ~D3DFVF_XYZRHW;
	if(m_m.flag_model & MODEL_SKIN){
		m_dwFVF &= ~D3DFVF_XYZ;
		m_dwFVF |= D3DFVF_XYZB1;
	}
	else{
		m_dwFVF &= ~D3DFVF_XYZB1;
		m_dwFVF |= D3DFVF_XYZ;
	}
	SAFE_RELEASE(m_m.pMesh);
	hr = D3DXCreateMeshFVF(t_face_ct, t_vtx_ct, D3DXMESH_MANAGED, m_dwFVF, pD3DDev, &m_m.pMesh);
	if(FAILED(hr))	goto End;
	// _WA@xNgAeNX`W̐ݒ
	hr = m_m.pMesh->LockVertexBuffer(D3DLOCK_DISCARD | D3DLOCK_DONOTWAIT, (LPVOID*)&pBuf);
	if(FAILED(hr))	goto End;
	for(i=0;i<m_m.parts_ct;i++){
		for(j=m_pp[i].vtx_ct;j<m_pp[i+1].vtx_ct;j++){
			memcpy(pBuf, &pv[j], sizeof(D3DXVECTOR3));
			pBuf += sizeof(D3DXVECTOR3);
			if(m_m.flag_model & MODEL_SKIN){
				memcpy(pBuf, &pb[j], sizeof(float));
				pBuf += sizeof(float);
			}
			if(m_dwFVF & D3DFVF_NORMAL){
				memcpy(pBuf, &pn[j], sizeof(D3DXVECTOR3));
				pBuf += sizeof(D3DXVECTOR3);
			}
			if(m_dwFVF & D3DFVF_DIFFUSE){
				DWORD color = D3DCOLOR_ARGB((BYTE)(m_pp[i].mtrl.Diffuse.a * 255),
											(BYTE)(m_pp[i].mtrl.Diffuse.r * 255),
											(BYTE)(m_pp[i].mtrl.Diffuse.g * 255),
											(BYTE)(m_pp[i].mtrl.Diffuse.b * 255));
				memcpy(pBuf, &color, sizeof(DWORD));
				pBuf += sizeof(DWORD);
			}
			if(m_dwFVF & D3DFVF_TEX1){
				memcpy(pBuf, &ptu[j], sizeof(float));
				pBuf += sizeof(float);
				memcpy(pBuf, &ptv[j], sizeof(float));
				pBuf += sizeof(float);
			}
		}
	}
	hr = m_m.pMesh->UnlockVertexBuffer();
	if(FAILED(hr))	goto End;
	
	// ʂ\Wԍ̐ݒ
	hr = m_m.pMesh->LockIndexBuffer(D3DLOCK_DISCARD | D3DLOCK_DONOTWAIT, (LPVOID*)&pBuf2);
	if(FAILED(hr))	goto End;
	for(i=0;i<m_m.parts_ct;i++){
		for(j=m_pp[i].face_ct;j<m_pp[i+1].face_ct;j++){
			*pBuf2 ++ = m_pf[j][0] + m_pp[i].vtx_ct;
			*pBuf2 ++ = m_pf[j][1] + m_pp[i].vtx_ct;
			*pBuf2 ++ = m_pf[j][2] + m_pp[i].vtx_ct;
		}
	}
	hr = m_m.pMesh->UnlockIndexBuffer();
	if(FAILED(hr))	goto End;
	
	// obt@ݒ
	hr = m_m.pMesh->LockAttributeBuffer(D3DLOCK_DISCARD | D3DLOCK_DONOTWAIT, &pBuf3);
	if(FAILED(hr))	goto End;
	for(i=0;i<m_m.parts_ct;i++){
		for(j=m_pp[i].face_ct;j<m_pp[i+1].face_ct;j++){
			*pBuf3 ++ = i;
		}
	}
	hr = m_m.pMesh->UnlockAttributeBuffer();
	if(FAILED(hr))	goto End;
	
	// e[uݒ
	pAttr = new D3DXATTRIBUTERANGE [m_m.parts_ct];
	if(!pAttr){
		hr = E_OUTOFMEMORY;
		goto End;
	}
	for(i=0;i<m_m.parts_ct;i++){
		pAttr[i].AttribId	 = i;
		pAttr[i].FaceStart	 = m_pp[i].face_ct;
		pAttr[i].FaceCount	 = m_pp[i+1].face_ct - m_pp[i].face_ct;
		pAttr[i].VertexStart = m_pp[i].vtx_ct;
		pAttr[i].VertexCount = m_pp[i+1].vtx_ct - m_pp[i].vtx_ct;
	}
	hr = m_m.pMesh->SetAttributeTable(pAttr, m_m.parts_ct);
	if(FAILED(hr))	goto End;
	
	// bVœKi`摬xj
	if( FAILED( hr = m_m.pMesh->OptimizeInplace(
						D3DXMESHOPT_COMPACT | D3DXMESHOPT_ATTRSORT | D3DXMESHOPT_IGNOREVERTS |
						D3DXMESHOPT_VERTEXCACHE | D3DXMESHOPT_DEVICEINDEPENDENT,
						NULL, NULL, NULL, NULL ) ) )
	{
		goto End;
	}

End:;
	SAFE_DELETE_ARRAY(pAttr);
	return hr;
}// CreateMesh

// 
void CFileECT::FreeFileMemory(D3DXVECTOR3 *pv, float *pb, D3DXVECTOR3 *pn,
								float *ptu, float *ptv)
{
	SAFE_DELETE_ARRAY(pv);
	SAFE_DELETE_ARRAY(pb);
	SAFE_DELETE_ARRAY(pn);
	SAFE_DELETE_ARRAY(ptu);
	SAFE_DELETE_ARRAY(ptv);
	SAFE_DELETE_ARRAY(m_pf);
}// FreeFileMemory

#endif