// tHOݒi_tHOsNZ tHÔǂ炩ݒ肷j
#ifndef _FOG_H_
#define _FOG_H_

#include <d3dx9.h>
#include "macro.h"

class CFog
{
public:
	HRESULT SetVertexFog(LPDIRECT3DDEVICE9 pD3DDev, D3DCOLOR color, float fStart, float fEnd,
						bool flag_quality);
	HRESULT SetPixelFog(LPDIRECT3DDEVICE9 pD3DDev, D3DCOLOR color, float fStart, float fEnd);
	void	SetFlagFog(LPDIRECT3DDEVICE9 pD3DDev, BOOL flag)
						{ if(pD3DDev){pD3DDev->SetRenderState(D3DRS_FOGENABLE, flag);} }
	BOOL	GetFlagFog(LPDIRECT3DDEVICE9 pD3DDev);
};

// _tHOݒ
// color		: [IN] tHOF
// fStart		: [IN] tHOJnWW
// fEnd 		: [IN] tHOIWW
// flag_quality : [IN] itOiTRUE or FALSEjAi͕`摬xx
HRESULT CFog::SetVertexFog(LPDIRECT3DDEVICE9 pD3DDev, D3DCOLOR color, float fStart, float fEnd,
							bool flag_quality)
{
	if(!pD3DDev)
		return E_FAIL;
	
	HRESULT  hr;
	D3DCAPS9 caps;
	hr = pD3DDev->GetDeviceCaps(&caps);
	hr = pD3DDev->SetRenderState(D3DRS_FOGENABLE,	   TRUE);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGCOLOR,	   color);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGTABLEMODE,   D3DFOG_NONE);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGVERTEXMODE,  D3DFOG_LINEAR);
	if(FAILED(hr))	return hr;
	if(flag_quality && (caps.RasterCaps & D3DPRASTERCAPS_FOGRANGE))
		hr = pD3DDev->SetRenderState(D3DRS_RANGEFOGENABLE, TRUE);
	else
		hr = pD3DDev->SetRenderState(D3DRS_RANGEFOGENABLE, FALSE);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGSTART,	   F2DW(fStart));
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGEND,		   F2DW(fEnd));
	if(FAILED(hr))	return hr;
	return hr;
}

// sNZ tHOݒ
// color  : [IN] tHOF
// fStart : [IN] tHOJnWW
// fEnd   : [IN] tHOIWW
HRESULT CFog::SetPixelFog(LPDIRECT3DDEVICE9 pD3DDev, D3DCOLOR color, float fStart, float fEnd)
{
	if(!pD3DDev)
		return E_FAIL;
	
	HRESULT  hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGENABLE,	   TRUE);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGCOLOR,	   color);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGTABLEMODE,   D3DFOG_LINEAR);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGVERTEXMODE,  D3DFOG_NONE);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_RANGEFOGENABLE, FALSE);
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGSTART,	   F2DW(fStart));
	if(FAILED(hr))	return hr;
	hr = pD3DDev->SetRenderState(D3DRS_FOGEND,		   F2DW(fEnd));
	if(FAILED(hr))	return hr;
	return hr;
}

// ݂̃tHOLtO擾iTRUE or FALSEj
BOOL CFog::GetFlagFog(LPDIRECT3DDEVICE9 pD3DDev)
{
	DWORD flag = FALSE;
	if(pD3DDev){
		pD3DDev->GetRenderState(D3DRS_FOGENABLE, &flag);
	}
	return (BOOL) flag;
}

#endif