// }N
// l^FC Magazine 2004N6 p.30 ` 31
#ifndef _RAND_H_
#define _RAND_H_

// from <= r <= to ƂȂdouble^̗Ԃ
inline double GetRandDouble(double from, double to)
{
	double r = (double)rand() / (double)RAND_MAX;
	return (from + r * (to - from));
}// GetRandDouble

// Kz
inline double GetRandGaussian(void)
{
	static int aNextFlag = 0;
	static double aNextAns;
	double aAns;
	if(aNextFlag == 0){
		double a1,a2,a3;
		do{
			a1 = GetRandDouble(-1,1);
			a2 = GetRandDouble(-1,1);
			a3 = a1 * a1 + a2 * a2;
		}while(a3 >= 1.0 || a3 == 0.0);
		a3 = sqrt(-2.0 * log(a3) / a3);
		aAns = a1 * a3;
		aNextAns = a2 * a3;
		aNextFlag = 1;
	}
	else{
		aAns = aNextAns;
		aNextFlag = 0;
	}
	return aAns;
}// GetRandGaussian

// Opz
// iNum 	F [IN] 킹鐔
// fRange	F [IN] ͈
inline double GetRandNormdist(int iNum, float fRange)
{
	int i;
	double sum = 0;
	for(i=0; i<iNum; i++){
		sum += GetRandDouble(-fRange, fRange);
	}
	return sum / iNum;
}// GetRandNormdist

// 0 ` iNum-1 ܂ł̃_ȐlԂ
inline int GetRand(int iNum)
{
	return (int)((float)iNum * rand() / (RAND_MAX + 1.0f));
}// GetRand

// Vbt
// piArray	F [IN][OUT] Vbtz
// iNum 	F [IN] 	 piArray ̗vf
inline int GetShuffle(int *piArray, int iNum)
{
	if(!piArray)
		return 0;
	
	int i,n,buf;
	for(i=0; i<iNum; i++){
		n = GetRand(i);
		buf = piArray[i];
		piArray[i] = piArray[n];
		piArray[n] = buf;
	}
}// GetShuffle

#endif