// GtFNgݒivO}v VF[_j
#ifndef _EFFECT_SH_H_
#define _EFFECT_SH_H_

// XL VF[_ R[h
const char g_szEffectNoSkin[] = 
"struct VS_IN"
"{"
	"float4 Pos    : POSITION;"		// _W
	"float3 Normal : NORMAL;"		// _@xNg
	"float2 Tex    : TEXCOORD0;"	// eNX`W
"};"

"struct VS_OUT"
"{"
	"float4 Pos    : POSITION;"
	"float2 Tex    : TEXCOORD0;"
	"float3 Normal : TEXCOORD1;"
"};"

"struct VSBUMP_IN"
"{"
	"float4 Pos      : POSITION;"
	"float3 Normal   : NORMAL;"
	"float3 Tangent  : TANGENT;"	// ڐxNg
	"float3 Binormal : BINORMAL;"	// ]@xNg
	"float2 Tex      : TEXCOORD0;"
"};"

"struct VSBUMP_OUT"
"{"
	"float4 Pos      : POSITION;"
	"float2 Tex      : TEXCOORD0;"
	"float3 Normal   : TEXCOORD1;"	// sNZ VF[_ɂ́ACOLOR  TEXCOORD nȂ
	"float3 Tangent  : TEXCOORD2;"	// ANormal, Tangent, Binormal  TEXCOORD őpB
	"float3 Binormal : TEXCOORD3;"	// ̂߁ATEXCOORD1`3 ̓eNX`WƂĂ͎gȂB
"};"								// DirectX10 ȍ~́ACOLOR  TEXCOORD ȊOnB

"struct PS_IN"
"{"
	"float2 Tex    : TEXCOORD0;"
	"float3 Normal : TEXCOORD1;"
"};"

"struct PSBUMP_IN"
"{"
	"float2 Tex      : TEXCOORD0;"
	"float3 Normal   : TEXCOORD1;"
	"float3 Tangent  : TEXCOORD2;"
	"float3 Binormal : TEXCOORD3;"
"};"

"struct PL_IN"
"{"
	"float3 Normal;"	// _@xNg
	"float2 Tex;"		// eNX`W
"};"

"float4x4 mtxWorld;"		// [hs
"float4x4 mtxAll;"			// [h~r[~vWFNVs
"float4   v4Diffuse;"		// fBt[YFi}eAj
"float3   v3Specular;"		// XyLFi}eAj
"float3   v3LightColor;"	// ƖF
"float3   v3Ambient;"		// F
"float    fSpecularPower;"	// XyLFxiXyLFȂ̏ꍇ -1j
"float3   v3Light;"			// Ɩ̌
"float3   v3Look;"			// ̌
"bool     bTexture;"		// eNX`̗L
"texture  texMain;"			// C eNX`
"texture  texBump;"			// ov eNX`

"sampler MainSampler = sampler_state"
"{"
	"Texture   = <texMain>;"
	"MinFilter = LINEAR;"
	"MagFilter = LINEAR;"
	"MipFilter = NONE;"
"};"

"sampler BumpSampler = sampler_state"
"{"
	"Texture   = <texBump>;"
	"MinFilter = LINEAR;"
	"MagFilter = LINEAR;"
	"MipFilter = NONE;"
"};"

// _VF[_֐isNZ CeBOj
"VS_OUT VS(VS_IN In)"
"{"
	"VS_OUT Out;"
	"Out.Pos    = mul(In.Pos, mtxAll);"
	"Out.Normal = normalize(mul(In.Normal, mtxWorld));"
	"Out.Tex    = In.Tex;"
	"return Out;"
"}"

// _VF[_֐iov }bsOj
"VSBUMP_OUT VSBUMP(VSBUMP_IN In)"
"{"
	"VSBUMP_OUT Out;"
	"Out.Pos      = mul(In.Pos, mtxAll);"
	"Out.Tex      = In.Tex;"
	"Out.Normal   = normalize(mul(In.Normal, mtxWorld));"
	"Out.Tangent  = normalize(mul(In.Tangent, mtxWorld));"
	"Out.Binormal = normalize(mul(In.Binormal, mtxWorld));"
	"return Out;"
"}"

// sNZ CeBO֐
"float4 PixelLighting(PL_IN In)"
"{"
	"float3 Diffuse,Specular,Reflect,Color;"
	// O[[ VF[fBOŃfBt[YFZo
	"Diffuse  = v4Diffuse.rgb * saturate(dot(In.Normal, v3Light));"
	// tH VF[fBOŃXyLFZo
	"Specular = 0;"
	"if(fSpecularPower >= 0){"
		"Reflect  = normalize(v3Light - 2 * Diffuse * In.Normal);"
		"Specular = v3Specular * pow(saturate(dot(Reflect, v3Look)), fSpecularPower);"
	"}"
	// fBt[YFɃeNX`Fǉ
	"if(bTexture){"
		"Diffuse = tex2D(MainSampler, In.Tex) * Diffuse;"
	"}"
	// fBt[YFAXyLFAArGgF𑫂킹
	"Color = v3LightColor * (Diffuse + Specular) + v3Ambient;"
	// xݒ肵ĕԂ
	"return float4(Color, v4Diffuse.a);"
"}"

// sNZ VF[_֐isNZ CeBOj
"float4 PS(PS_IN In) : COLOR"
"{"
	"PL_IN pl = {In.Normal, In.Tex};"
	"return PixelLighting(pl);"
"}"

// sNZ VF[_֐iov }bsOj
"float4 PSBUMP(PSBUMP_IN In) : COLOR"
"{"
	"float3   Normal;"
	// ڐA]@A@xNgϊs쐬
	"float3x3 mtxNormal = {In.Tangent, In.Binormal, In.Normal};"
	// @}bv@xNg쐬
	"Normal = 2.0 * tex2D(BumpSampler, In.Tex).xyz - 1.0;"
	// @}bv̖@xNg𒸓_@xNǧɉ]
	"Normal = normalize(mul(Normal, mtxNormal));"
	// ov@xNgŃtH VF[fBO
	"PL_IN pl = {Normal, In.Tex};"
	"return PixelLighting(pl);"
"}"

"technique tecDirectionalLight"
"{"
	"pass P0"
	"{"
		// _VF[_֐̃RpC
		// _VF[_͒_Ƃ̏ł
		"VertexShader = compile vs_2_0 VS();"
		// sNZ VF[_֐̃RpC
		// sNZ VF[_̓sNZƂ̏ł
		"PixelShader  = compile ps_2_0 PS();"
	"}"
"}"

"technique tecBumpDirectionalLight"
"{"
	"pass P0"
	"{"
		"VertexShader = compile vs_2_0 VSBUMP();"
		"PixelShader  = compile ps_2_0 PSBUMP();"
	"}"
"}";

//------------------------------------------------------------------------------------

// ԍtXL VF[_ R[h
const char g_szEffectIndexSkin[] = 
"float4   v4Diffuse;"		// fBt[YFi}eAj
"float3   v3Specular;"		// XyLFi}eAj
"float3   v3LightColor;"	// ƖF
"float3   v3Ambient;" 		// F
"float    fSpecularPower;"	// XyLFxiXyLFȂ̏ꍇ -1j
"float3   v3Light;"			// Ɩ̌
"float3   v3Look;"			// ̌
"bool     bTexture;"		// eNX`̗L
"texture  texMain = NULL;"	// C eNX`
"texture  texBump = NULL;"	// ov eNX`

"static const int MAX_MATRICES = 26;"
"float4x3 mtxWorlds[MAX_MATRICES] : WORLDMATRIXARRAY;"
"float4x4 mtxViewProj : VIEWPROJECTION;"

"sampler MainSampler = sampler_state"
"{"
	"Texture   = <texMain>;"
	"MinFilter = LINEAR;"
	"MagFilter = LINEAR;"
	"MipFilter = NONE;"
"};"

"sampler BumpSampler = sampler_state"
"{"
	"Texture   = <texBump>;"
	"MinFilter = LINEAR;"
	"MagFilter = LINEAR;"
	"MipFilter = NONE;"
"};"

"struct VSINDEXSKIN_IN"
"{"
	"float4	Pos          : POSITION;"		// _W
	"float4	BlendWeights : BLENDWEIGHT;"	// XL̏d
	"float4	BlendIndices : BLENDINDICES;"	// XL̏dݔԍ
	"float3	Normal       : NORMAL;"			// _@
	"float2	Tex          : TEXCOORD0;"		// eNX`W
"};"

"struct VS_OUT"
"{"
	"float4 Pos    : POSITION;"
	"float2 Tex    : TEXCOORD0;"
	"float3 Normal : TEXCOORD1;"
"};"

"struct VSINDEXSKINBUMP_IN"
"{"
	"float4 Pos          : POSITION;"
	"float4	BlendWeights : BLENDWEIGHT;"
	"float4	BlendIndices : BLENDINDICES;"
	"float3 Normal       : NORMAL;"
	"float3 Tangent      : TANGENT;"
	"float2 Tex          : TEXCOORD0;"
"};"

"struct VSBUMP_OUT"
"{"
	"float4 Pos      : POSITION;"
	"float2 Tex      : TEXCOORD0;"
	"float3 Normal   : TEXCOORD1;"
	"float3 Tangent  : TEXCOORD2;"
	"float3 Binormal : TEXCOORD3;"
"};"

"struct PS_IN"
"{"
	"float2 Tex    : TEXCOORD0;"
	"float3 Normal : TEXCOORD1;"
"};"

"struct PSBUMP_IN"
"{"
	"float2 Tex      : TEXCOORD0;"
	"float3 Normal   : TEXCOORD1;"
	"float3 Tangent  : TEXCOORD2;"
	"float3 Binormal : TEXCOORD3;"
"};"

"struct PL_IN"
"{"
	"float3 Normal;"
	"float2 Tex;"
"};"

// _VF[_֐isNZ CeBOj
"VS_OUT VSINDEXSKIN(VSINDEXSKIN_IN In, uniform int NumBones)"
"{"
	"VS_OUT Out;"
	"float3 Pos = 0.0f;"
	"float3 Normal = 0.0f;"
	"float  LastWeight = 0.0f;"
	"int4   IndexVector = D3DCOLORtoUBYTE4(In.BlendIndices);"
	"float  BlendWeightsArray[4] = (float[4])In.BlendWeights;"
	"int    IndexArray[4]		 = (int[4])IndexVector;"
	"int    iBone;"
	"for (iBone = 0; iBone < NumBones-1; iBone++)"
	"{"
		"LastWeight = LastWeight + BlendWeightsArray[iBone];"
		"Pos    += mul(In.Pos, mtxWorlds[IndexArray[iBone]]) * BlendWeightsArray[iBone];"
		"Normal += mul(In.Normal, mtxWorlds[IndexArray[iBone]]) * BlendWeightsArray[iBone];"
	"}"
	"LastWeight = 1.0f - LastWeight;"
	"Pos    += mul(In.Pos, mtxWorlds[IndexArray[NumBones-1]]) * LastWeight;"
	"Normal += mul(In.Normal, mtxWorlds[IndexArray[NumBones-1]]) * LastWeight;"
	"Out.Pos    = mul(float4(Pos.xyz, 1.0f), mtxViewProj);"
	"Out.Normal = normalize(Normal);"
	"Out.Tex    = In.Tex;"
	"return Out;"
"}"

// _VF[_֐iov }bsOj
"VSBUMP_OUT VSINDEXSKINBUMP(VSINDEXSKINBUMP_IN In, uniform int NumBones)"
"{"
	"VSBUMP_OUT Out;"
	"float3     Pos = 0.0f;"
	"float3     Normal = 0.0f;"
	"float3     Tangent = 0.0f;"
	"float      LastWeight = 0.0f;"
	"int4       IndexVector = D3DCOLORtoUBYTE4(In.BlendIndices);"
	"float      BlendWeightsArray[4] = (float[4])In.BlendWeights;"
	"int        IndexArray[4]		 = (int[4])IndexVector;"
	"int        iBone;"
	"for (iBone = 0; iBone < NumBones-1; iBone++)"
	"{"
		"LastWeight = LastWeight + BlendWeightsArray[iBone];"
		"Pos     += mul(In.Pos,	   mtxWorlds[IndexArray[iBone]]) * BlendWeightsArray[iBone];"
		"Normal  += mul(In.Normal,  mtxWorlds[IndexArray[iBone]]) * BlendWeightsArray[iBone];"
		"Tangent += mul(In.Tangent, mtxWorlds[IndexArray[iBone]]) * BlendWeightsArray[iBone];"
	"}"
	"LastWeight = 1.0f - LastWeight;"
	"Pos     += mul(In.Pos,	   mtxWorlds[IndexArray[NumBones-1]]) * LastWeight;"
	"Normal  += mul(In.Normal,  mtxWorlds[IndexArray[NumBones-1]]) * LastWeight;"
	"Tangent += mul(In.Tangent, mtxWorlds[IndexArray[NumBones-1]]) * LastWeight;"
	"Out.Pos      = mul(float4(Pos.xyz, 1.0f), mtxViewProj);"
	"Out.Normal   = normalize(Normal);"
	"Out.Tangent  = normalize(Tangent);"
	"Out.Binormal = cross(Out.Normal, Out.Tangent);"
	"Out.Tex      = In.Tex;"
	"return Out;"
"}"

// sNZ CeBO֐
"float4 PixelLighting(PL_IN In)"
"{"
	"float3 Diffuse,Specular,Reflect,Color;"
	"Diffuse  = v4Diffuse.rgb * saturate(dot(In.Normal, v3Light));"
	"Specular = 0;"
	"if(fSpecularPower > 0){"
		"Reflect  = normalize(v3Light - 2 * Diffuse * In.Normal);"
		"Specular = v3Specular * pow(saturate(dot(Reflect, v3Look)), fSpecularPower);"
	"}"
	"if(bTexture){"
		"Diffuse = tex2D(MainSampler, In.Tex) * Diffuse;"
	"}"
	"Color = v3LightColor * (Diffuse + Specular) + v3Ambient;"
	"return float4(Color, v4Diffuse.a);"
"}"

// sNZ VF[_֐isNZ CeBOj
"float4 PS(PS_IN In) : COLOR"
"{"
	"PL_IN pl = {In.Normal, In.Tex};"
	"return PixelLighting(pl);"
"}"

// sNZ VF[_֐iov }bsOj
"float4 PSBUMP(PSBUMP_IN In) : COLOR"
"{"
	"float3	 Normal;"
	"float3x3 mtxNormal = {In.Tangent, In.Binormal, In.Normal};"
	"Normal   = 2.0 * tex2D(BumpSampler, In.Tex).xyz - 1.0;"
	"Normal   = normalize(mul(Normal, mtxNormal));"
	"PL_IN pl = {Normal, In.Tex};"
	"return PixelLighting(pl);"
"}"

"int CurNumBones = 2;"
"VertexShader vsArray[4] = { compile vs_2_0 VSINDEXSKIN(1),"
							"compile vs_2_0 VSINDEXSKIN(2),"
							"compile vs_2_0 VSINDEXSKIN(3),"
							"compile vs_2_0 VSINDEXSKIN(4)"
						  "};"

"VertexShader vsArrayBump[4] = { compile vs_2_0 VSINDEXSKINBUMP(1),"
								"compile vs_2_0 VSINDEXSKINBUMP(2),"
								"compile vs_2_0 VSINDEXSKINBUMP(3),"
								"compile vs_2_0 VSINDEXSKINBUMP(4)"
							  "};"

"technique tecSkinDirectionalLight"
"{"
	"pass P0"
	"{"
		"VertexShader = (vsArray[CurNumBones]);"
		"PixelShader  = compile ps_2_0 PS();"
	"}"
"}"

"technique tecSkinBumpDirectionalLight"
"{"
	"pass P0"
	"{"
		"VertexShader = (vsArrayBump[CurNumBones]);"
		"PixelShader  = compile ps_2_0 PSBUMP();"
	"}"
"}";

//------------------------------------------------------------------------------------

// XL VF[_ R[h
const char g_szEffectSkin[] = 
"float4   v4Diffuse;"		// fBt[YFi}eAj
"float3   v3Specular;"		// XyLFi}eAj
"float3   v3LightColor;"	// ƖF
"float3   v3Ambient;" 		// F
"float    fSpecularPower;"	// XyLFxiXyLFȂ̏ꍇ -1j
"float3   v3Light;"			// Ɩ̌
"float3   v3Look;"			// ̌
"bool     bTexture;"		// eNX`̗L
"texture  texMain = NULL;"	// C eNX`
"texture  texBump = NULL;"	// ov eNX`

"float4x3 mtxWorlds[2] : WORLDMATRIXARRAY;"
"float4x4 mtxViewProj  : VIEWPROJECTION;"

"sampler MainSampler = sampler_state"
"{"
	"Texture   = <texMain>;"
	"MinFilter = LINEAR;"
	"MagFilter = LINEAR;"
	"MipFilter = NONE;"
"};"

"sampler BumpSampler = sampler_state"
"{"
	"Texture   = <texBump>;"
	"MinFilter = LINEAR;"
	"MagFilter = LINEAR;"
	"MipFilter = NONE;"
"};"

"struct VSSKIN_IN"
"{"
	"float4	Pos         : POSITION;"	// _W
	"float	BlendWeight : BLENDWEIGHT;"	// XL̏d
	"float3	Normal      : NORMAL;"		// _@
	"float2	Tex         : TEXCOORD0;"	// eNX`W
"};"

"struct VS_OUT"
"{"
	"float4 Pos    : POSITION;"
	"float2 Tex    : TEXCOORD0;"
	"float3 Normal : TEXCOORD1;"
"};"

"struct VSSKINBUMP_IN"
"{"
	"float4 Pos         : POSITION;"
	"float	BlendWeight : BLENDWEIGHT;"
	"float3 Normal      : NORMAL;"
	"float3 Tangent     : TANGENT;"
	"float2 Tex         : TEXCOORD0;"
"};"

"struct VSBUMP_OUT"
"{"
	"float4 Pos      : POSITION;"
	"float2 Tex      : TEXCOORD0;"
	"float3 Normal   : TEXCOORD1;"
	"float3 Tangent  : TEXCOORD2;"
	"float3 Binormal : TEXCOORD3;"
"};"

"struct PS_IN"
"{"
	"float2 Tex    : TEXCOORD0;"
	"float3 Normal : TEXCOORD1;"
"};"

"struct PSBUMP_IN"
"{"
	"float2 Tex      : TEXCOORD0;"
	"float3 Normal   : TEXCOORD1;"
	"float3 Tangent  : TEXCOORD2;"
	"float3 Binormal : TEXCOORD3;"
"};"

"struct PL_IN"
"{"
	"float3 Normal;"
	"float2 Tex;"
"};"

// _VF[_֐isNZ CeBOj
"VS_OUT VSSKIN(VSSKIN_IN In)"
"{"
	"VS_OUT Out;"
	"float3 Pos    = mul(In.Pos,    mtxWorlds[0]) * In.BlendWeight;"
	"float3 Normal = mul(In.Normal, mtxWorlds[0]) * In.BlendWeight;"
	"float  LastWeight = 1.0f - In.BlendWeight;"
	"Pos    += mul(In.Pos,    mtxWorlds[1]) * LastWeight;"
	"Normal += mul(In.Normal, mtxWorlds[1]) * LastWeight;"
	"Out.Pos    = mul(float4(Pos.xyz, 1.0f), mtxViewProj);"
	"Out.Normal = normalize(Normal);"
	"Out.Tex    = In.Tex;"
	"return Out;"
"}"

// _VF[_֐iov }bsOj
"VSBUMP_OUT VSSKINBUMP(VSSKINBUMP_IN In)"
"{"
	"VSBUMP_OUT Out;"
	"float3 Pos     = mul(In.Pos,     mtxWorlds[0]) * In.BlendWeight;"
	"float3 Normal  = mul(In.Normal,  mtxWorlds[0]) * In.BlendWeight;"
	"float3 Tangent = mul(In.Tangent, mtxWorlds[0]) * In.BlendWeight;"
	"float  LastWeight = 1.0f - In.BlendWeight;"
	"Pos     += mul(In.Pos,	    mtxWorlds[1]) * LastWeight;"
	"Normal  += mul(In.Normal,  mtxWorlds[1]) * LastWeight;"
	"Tangent += mul(In.Tangent, mtxWorlds[1]) * LastWeight;"
	"Out.Pos      = mul(float4(Pos.xyz, 1.0f), mtxViewProj);"
	"Out.Normal   = normalize(Normal);"
	"Out.Tangent  = normalize(Tangent);"
	"Out.Binormal = cross(Out.Normal, Out.Tangent);"
	"Out.Tex      = In.Tex;"
	"return Out;"
"}"

// sNZ CeBO֐
"float4 PixelLighting(PL_IN In)"
"{"
	"float3 Diffuse,Specular,Reflect,Color;"
	"Diffuse  = v4Diffuse.rgb * saturate(dot(In.Normal, v3Light));"
	"Specular = 0;"
	"if(fSpecularPower > 0){"
		"Reflect  = normalize(v3Light - 2 * Diffuse * In.Normal);"
		"Specular = v3Specular * pow(saturate(dot(Reflect, v3Look)), fSpecularPower);"
	"}"
	"if(bTexture){"
		"Diffuse = tex2D(MainSampler, In.Tex) * Diffuse;"
	"}"
	"Color = v3LightColor * (Diffuse + Specular) + v3Ambient;"
	"return float4(Color, v4Diffuse.a);"
"}"

// sNZ VF[_֐isNZ CeBOj
"float4 PS(PS_IN In) : COLOR"
"{"
	"PL_IN pl = {In.Normal, In.Tex};"
	"return PixelLighting(pl);"
"}"

// sNZ VF[_֐iov }bsOj
"float4 PSBUMP(PSBUMP_IN In) : COLOR"
"{"
	"float3	 Normal;"
	"float3x3 mtxNormal = {In.Tangent, In.Binormal, In.Normal};"
	"Normal   = 2.0 * tex2D(BumpSampler, In.Tex).xyz - 1.0;"
	"Normal   = normalize(mul(Normal, mtxNormal));"
	"PL_IN pl = {Normal, In.Tex};"
	"return PixelLighting(pl);"
"}"

"technique tecSkinDirectionalLight"
"{"
	"pass P0"
	"{"
		"VertexShader = compile vs_2_0 VSSKIN();"
		"PixelShader  = compile ps_2_0 PS();"
	"}"
"}"

"technique tecSkinBumpDirectionalLight"
"{"
	"pass P0"
	"{"
		"VertexShader = compile vs_2_0 VSSKINBUMP();"
		"PixelShader  = compile ps_2_0 PSBUMP();"
	"}"
"}";

//------------------------------------------------------------------------------------

typedef struct{
	D3DXMATRIX		mtxWorld;			// [hs
	D3DXMATRIX		mtxView;			// r[s
	D3DXMATRIX		mtxProjection;		// vWFNVs
	D3DXVECTOR3		v3LightDirection;	// Ǝ˃xNg
	D3DXVECTOR3		v3LookDirection;	// xNg
	D3DCOLORVALUE	rgbaLightColor;		// ƖF
	D3DCOLORVALUE	rgbaAmbient;		// 
	bool			bBump;				// ovtOi0:Ȃ,1:j
}EFFECTDATA,*LPEFFECTDATA;

//------------------------------------------------------------------------------------

class CEffect
{
public:
	CEffect();
	virtual			~CEffect();
	HRESULT			Init(LPDIRECT3DDEVICE9 pD3DDev, int iECT);
	HRESULT			SetDataCommon(LPEFFECTDATA data);
	HRESULT			SetDataNoSkin(LPEFFECTDATA data);
	void			Free();
	LPD3DXEFFECT	GetEffectNoSkin() { return m_pEffectNoSkin; }
	LPD3DXEFFECT	GetEffectSkin()   { return m_pEffectSkin; }
	
private:
	LPD3DXEFFECT	m_pEffectNoSkin;	// GtFNgiXLj
	LPD3DXEFFECT	m_pEffectSkin;		// GtFNgiXLj
};

CEffect::CEffect()
{
	m_pEffectNoSkin = NULL;
	m_pEffectSkin   = NULL;
}

CEffect::~CEffect()
{
	Free();
}

// 
// pD3DDev : [IN] IDirect3DDevice9 IuWFNg
// iECT    : [IN] t@CʃtOi0:Xt@CAjȂA1:Xt@CAjA2:ECTt@Cj
HRESULT CEffect::Init(LPDIRECT3DDEVICE9 pD3DDev, int iECT)
{
	if(!pD3DDev)
		return E_FAIL;
	
	HRESULT  hr;
	
	// GtFNgǂݍ
	hr = D3DXCreateEffect(pD3DDev, g_szEffectNoSkin, strlen(g_szEffectNoSkin),
							NULL, NULL, 0, NULL, &m_pEffectNoSkin, NULL);
	switch (iECT)
	{
	case 0:	// Xt@CAjȂ
		break;
	case 1:	// Xt@CAj
		hr = D3DXCreateEffect(pD3DDev, g_szEffectIndexSkin, strlen(g_szEffectIndexSkin),
								NULL, NULL, 0, NULL, &m_pEffectSkin, NULL);
		break;
	case 2:	// ECTt@C
		hr = D3DXCreateEffect(pD3DDev, g_szEffectSkin, strlen(g_szEffectSkin),
								NULL, NULL, 0, NULL, &m_pEffectSkin, NULL);
		break;
	}
	
	return hr;
}

// VF[_Ƀf[^𑗂iʁj
// data : [IN] VF[_ɑf[^
HRESULT CEffect::SetDataCommon(LPEFFECTDATA data)
{
	HRESULT		hr;
	D3DXVECTOR4 v4Light(data->v3LightDirection.x,
						data->v3LightDirection.y,
						data->v3LightDirection.z,
						0);
	D3DXVECTOR4 v4Look(data->v3LookDirection.x,
						data->v3LookDirection.y,
						data->v3LookDirection.z,
						0);
	D3DXVec4Normalize(&v4Light, &v4Light);
	D3DXVec4Normalize(&v4Look,  &v4Look);
	if(m_pEffectNoSkin){
		hr = m_pEffectNoSkin->SetVector("v3Light",      &v4Light);
		hr = m_pEffectNoSkin->SetVector("v3Look",       &v4Look);
		hr = m_pEffectNoSkin->SetVector("v3LightColor", (LPD3DXVECTOR4) &(data->rgbaLightColor));
		hr = m_pEffectNoSkin->SetVector("v3Ambient",    (LPD3DXVECTOR4) &(data->rgbaAmbient));
	}
	if(m_pEffectSkin){
		hr = m_pEffectSkin->SetVector("v3Light",      &v4Light);
		hr = m_pEffectSkin->SetVector("v3Look",       &v4Look);
		hr = m_pEffectSkin->SetVector("v3LightColor", (LPD3DXVECTOR4) &(data->rgbaLightColor));
		hr = m_pEffectSkin->SetVector("v3Ambient",    (LPD3DXVECTOR4) &(data->rgbaAmbient));
	}
	
	return hr;
}

// VF[_Ƀf[^𑗂iXLj
// data : [IN] VF[_ɑf[^
HRESULT CEffect::SetDataNoSkin(LPEFFECTDATA data)
{
	if(!m_pEffectNoSkin)
		return E_FAIL;
	
	HRESULT	hr;
	hr = m_pEffectNoSkin->SetMatrix("mtxWorld",	&(data->mtxWorld));
	hr = m_pEffectNoSkin->SetMatrix("mtxAll",	&(data->mtxWorld * data->mtxView *
												data->mtxProjection));
	
	return hr;
}

// ̉
void CEffect::Free()
{
	SAFE_RELEASE(m_pEffectNoSkin);
	SAFE_RELEASE(m_pEffectSkin);
}

#endif